const Emitter = require('event-listener-emitter')
const Route = require('hash-path')

class Router {

  constructor () {
    this.events = new Emitter()
    this._routes = []
    this._route = {}
  }

  add (path, state) {
    let route = new Route({ path: path })
    let config = { path: route, state: state }
    this._routes.push(config)
    return route
  }

  dispatch (path) {
    let routes = this._routes

    for (let route of routes) {
      let matching = route.path.match(path)
      if (matching) {
        let to_state = route.state
        if (typeof matching === 'object') {
          to_state.params = matching
        } else {
          to_state.params = {}
        }
        let from_state = this._route.state
        this._update(to_state, from_state)
        this._route = route
        return
      }
    }
  }

  _update (to_state, from_state) {
    let transition = { to_state, from_state }
    this.events.emit('change', transition)
  }

}

module.exports = Router
